Index: common/db/score.php
===================================================================
--- common/db/score.php	(revision 1164)
+++ common/db/score.php	(working copy)
@@ -372,9 +372,7 @@ function score_get_rankings($rounds, $tasks, $start = 0, $count = 999999,
     // Get the total score for all rounds
     $query = "
         SELECT ".(count($rounds) > 1 ? "SUM(score) AS score" : "score").",
-                user_id, ia_user.username AS user_name,
-                ia_user.full_name AS user_full,
-                ia_user.rating_cache AS user_rating
+                user_id AS id, ia_user.*
         FROM ia_score_user_round
         LEFT JOIN ia_user ON ia_user.id = ia_score_user_round.user_id
         WHERE".implode('AND', $where)."
@@ -389,7 +387,7 @@ function score_get_rankings($rounds, $tasks, $start = 0, $count = 999999,
 
     $users = array();
     foreach ($rankings as $ranking) {
-        array_push($users, $ranking['user_id']);
+        array_push($users, $ranking['id']);
     }
 
     // Further queries concern only the users that are in this rankings page
@@ -440,7 +438,7 @@ function score_get_rankings($rounds, $tasks, $start = 0, $count = 999999,
 
     //create all entries
     for ($i = 0; $i < count($rankings); $i++) {
-        $user_id = $rankings[$i]['user_id'];
+        $user_id = $rankings[$i]['id'];
 
         //task columns
         if ($detail_task == true) {
@@ -450,7 +448,7 @@ function score_get_rankings($rounds, $tasks, $start = 0, $count = 999999,
                 } else {
                     $score = 0;
                 }
-                $rankings[$i][$task_id] = $score;
+                $rankings[$i]['task_scores_' . $task_id] = $score;
             }
         }
 
@@ -462,7 +460,7 @@ function score_get_rankings($rounds, $tasks, $start = 0, $count = 999999,
                 } else {
                     $score = 0;
                 }
-                $rankings[$i][$round_id] = $score;
+                $rankings[$i]['round_scores_' . $round_id] = $score;
             }
         }
 
Index: common/db/textblock.php
===================================================================
--- common/db/textblock.php	(revision 1164)
+++ common/db/textblock.php	(working copy)
@@ -117,9 +117,11 @@ function textblock_complex_query($options)
         $field_list .= ", `text`";
     }
 
+    //FIXME: get username as username and full_name as full_mame, no conflicts here so why mess up?
     // Add a join for username.
     if (getattr($options, 'username', false) == true) {
-        $field_list .= ", `username` as `user_name`, `full_name` as `user_fullname`, rating_cache";
+        $field_list .= ", `username` as `user_name`, `full_name` as `user_fullname`, rating_cache"
+                . ", security_level, avatar_timestamp";
         $join = "LEFT JOIN ia_user ON `user_id` = `ia_user`.`id`";
     } else {
         $join = "";
@@ -234,11 +236,11 @@ function textblock_get_revision_count($name) {
     $name = normalize_page_name($name);
     log_assert(is_normal_page_name($name));
 
-    $query = sprintf("SELECT COUNT(*) AS `cnt` FROM ia_textblock_revision
+    $query = sprintf("SELECT COUNT(*) AS `count` FROM ia_textblock_revision
                       WHERE `name` = '%s'",
                     db_escape(strtolower($name)));
     $row = db_fetch($query);
-    return $row['cnt'] + 1;
+    return $row['count'] + 1;
 }
 
 // Grep through textblocks. This is mostly a hack needed for macro_grep.php
Index: common/db/user.php
===================================================================
--- common/db/user.php	(revision 1164)
+++ common/db/user.php	(working copy)
@@ -166,6 +166,7 @@ function user_create($user, $remote_ip_info=null)
 // Also updates SMF, which is good.
 function user_update($user)
 {
+    $user['avatar_timestamp'] = time();
     log_assert_valid(user_validate($user));
 
     // Update DB
Index: common/security.php
===================================================================
--- common/security.php	(revision 1164)
+++ common/security.php	(working copy)
@@ -131,11 +131,11 @@ function security_simplify_action($action) {
         case 'task-delete':
         case 'task-tag':
         case 'task-reeval':
-        case 'task-edit-ratings': 
+        case 'task-edit-ratings':
         case 'textblock-delete':
         case 'textblock-delete-revision':
         case 'round-tag':
-        case 'round-view-progress': 
+        case 'round-view-progress':
         case 'grader-overwrite':
         case 'grader-delete':
         case 'grader-rename':
@@ -181,6 +181,105 @@ function security_simplify_action($action) {
     }
 }
 
+/**
+ * Ask for the available actions on the object
+ * For use in XHP objects so they won't query the identity user
+ * FIXME: add all the other object types security queries
+ *
+ * @param  $user    array
+ * @param  $object  array
+ * @return array
+ */
+function security_actions_query($user, $object) {
+    log_assert(is_array($object),
+        '$object must be an array');
+
+    if (IA_LOG_SECURITY) {
+        $username = getattr($user, 'username', 'null');
+        $security_level = getattr($user, 'security_level', 'anonymus');
+        $object_name = getattr($object, 'name', $object);
+        log_print("SECURITY QUERY: ($username, $security_level, $object): "
+                . "(username, level, object)");
+    }
+
+    switch ($object['type']) {
+        case 'textblock':
+           $actions = security_actions_textblock($user, $object);
+           break;
+
+        default:
+            log_error('Invalid type of object: ' . $object['type']);
+    }
+
+    if (IA_LOG_SECURITY) {
+        if (count($actions) == 0) {
+            log_print("NO ACTIONS");
+        } else {
+            log_print_r($actions);
+        }
+    }
+
+    return $actions;
+}
+
+/**
+ * Checks what actions an user can perform on a given textblock
+ * For use in XHP object
+ *
+ * @param  $user       the user array containing all the necessary
+ *                     information about the user
+ * @param  $textblock
+ * @return array
+ */
+function security_actions_textblock($user, $textblock) {
+    $user_security_level = getattr($user, 'security_level', 'anonymus');
+    $textblock_security_level = getattr($textblock, 'security');
+
+    $view_actions = array('view', 'history', 'list-attach');
+    $sensitive_info = array('view-ip');
+    $reversible_actions = array('edit', 'restore', 'attach', 'create',
+            'change-topic', 'copy');
+    $admin_actions = array('move', 'delete', 'delete-revision',
+            'change-security', 'tag');
+
+    $actions = array();
+    if ($textblock_security_level == 'public') {
+        switch ($user_security_level) {
+            case 'admin':
+                $actions = array_merge($actions, $admin_actions);
+            case 'intern':
+            case 'helper':
+                $actions = array_merge($actions, $sensitive_info);
+            case 'normal':
+                $actions = array_merge($actions, $reversible_actions);
+            default:
+                $actions = array_merge($actions, $view_actions);
+                break;
+        }
+    } elseif ($textblock_security_level == 'protected') {
+        switch ($user_security_level) {
+            case 'admin':
+                $actions = array_merge($actions, $admin_actions,
+                        $reversible_actions);
+            case 'intern':
+            case 'helper':
+                $actions = array_merge($actions, $sensitive_info);
+            case 'normal':
+            default:
+                $actions = array_merge($actions, $view_actions);
+        }
+    } else {
+        if ($user_security_level == 'admin') {
+            $actions = array_merge($admin_actions, $sensitive_info,
+                    $reversible_actions, $view_actions);
+        } else {
+            $actions = array();
+        }
+    }
+
+    return $actions;
+}
+
 // Handles textblock security.
 function security_textblock($user, $action, $textblock) {
     require_once(IA_ROOT_DIR."common/textblock.php");
@@ -254,7 +353,7 @@ function security_textblock($user, $action, $textblock) {
             }
 
         case 'sensitive-info':
-            return ($usersec == 'admin' || $usersec == 'helper');
+            return ($usersec == 'admin' || $usersec == 'intern' || $usersec == 'helper');
 
         // Reversible modifications.
         case 'simple-rev-edit':
Index: common/textblock.php
===================================================================
--- common/textblock.php	(revision 1164)
+++ common/textblock.php	(working copy)
@@ -10,15 +10,15 @@ function hijack_title(&$text, $url, $title) {
     if (preg_match('/^\s*<h1>(.*)<\/h1>(.*)$/sxi', $text, $matches)) {
         $text = $matches[2];
         if (is_null($url)) {
-            return '<h1>'.$matches[1].'</h1>';
+            return <h1> {$matches[1]} </h1>;
         } else {
-            return '<h1>'.format_link($url, $matches[1], false).'</h1>';
+            return <h1> <ui:link href={$url}> {$matches[1]} </ui:link> </h1>;
         }
     } else {
         if (is_null($url)) {
-            return '<h1>'.html_escape($title).'</h1>';
+            return <h1> {$title} </h1>;
         } else {
-            return '<h1>'.format_link($url, $title).'</h1>';
+            return <h1> <ui:link href={$url}> {$title} </ui:link> </h1>;
         }
     }
 }
Index: common/user.php
===================================================================
--- common/user.php	(revision 1164)
+++ common/user.php	(working copy)
@@ -103,15 +103,25 @@ function user_validate($user) {
     } else if ($user['newsletter'] != '0' && $user['newsletter'] != '1') {
         $errors['newsletter'] = "Se accepta doar 0/1";
     }
-    
+
     return $errors;
 }
 
-function user_is_admin($user) {
+/**
+ * Checks if the user is an admin
+ * the second parameter is used to tell if it's just for formality( such as
+ * <ui:user:* /> tags which do not have any effect on the database
+ * @param  string  $user
+ * @param  bool    @validate
+ * @return bool
+ */
+function user_is_admin($user, $validate = true) {
     if (!$user) {
         return false;
     }
-    log_assert_valid(user_validate($user));
+    if ($validate == true) {
+        log_assert_valid(user_validate($user));
+    }
     return $user['security_level'] === 'admin';
 }
 
Index: scripts/add-avatar-timestamps
new file mode 100755
===================================================================
--- scripts/add-avatar-timestamps	(revision 0)
+++ scripts/add-avatar-timestamps	(working copy)
@@ -0,0 +1,18 @@
+#! /usr/bin/env php
+<?php
+
+require_once(dirname($argv[0]) . '/utilities.php');
+require_once(IA_ROOT_DIR . 'common/db/db.php');
+require_once(IA_ROOT_DIR . 'common/cache.php');
+
+db_connect();
+
+$result = db_query("SHOW COLUMNS FROM `ia_user` LIKE 'avatar_timestamp'");
+if (mysql_num_rows($result) == 0) {
+    $query = "ALTER TABLE `ia_user` ADD COLUMN avatar_timestamp INT";
+    db_query($query);
+}
+
+db_query("UPDATE `ia_user` SET `avatar_timestamp` = " . time());
+mem_cache_purge();
+?>
Index: smf/Themes/default/index.template.php
===================================================================
--- smf/Themes/default/index.template.php	(revision 1164)
+++ smf/Themes/default/index.template.php	(working copy)
@@ -29,7 +29,7 @@
 	http://www.simplemachines.org/
 */
 
-require_once(IA_ROOT_DIR.'www/views/sitewide.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ia/sitewide.php');
 
 // Initialize the template... mainly little settings.
 function template_init()
@@ -209,7 +209,7 @@ function template_main_above()
 </div>
 
 <?php*/
-	ia_template_header();
+	echo <ia:header user={identity_get_user()} />;
 
 	// Show the menu here, according to the menu sub template.
 	template_menu();
@@ -255,7 +255,7 @@ function template_main_below()
 		<span class="smalltext">', $txt['smf301'], $context['load_time'], $txt['smf302'], $context['load_queries'], $txt['smf302b'], '</span>';
 
 	// throw in infoarena footer
-	ia_template_footer();
+	echo <ia:footer />;
 
 	// This is an interesting bug in Internet Explorer AND Safari. Rather annoying, it makes overflows just not tall enough.
 	if (($context['browser']['is_ie'] && !$context['browser']['is_ie4']) || $context['browser']['is_mac_ie'] || $context['browser']['is_safari'] || $context['browser']['is_firefox'])
@@ -388,7 +388,10 @@ function template_menu() {
 	$smf_admin = $context['allow_admin'];
 
 	// display menu
-	ia_template_topnav($current_action, $smf_admin);
+	echo <ia:top-navbar
+		user={identity_get_user()} selected={$current_action}
+		user_pm_count={identity_is_anonymous() ? null :
+		               smf_get_pm_count(identity_get_username())} />;
 	if ($context['user']['is_logged']) {
 		echo '<div style="float: right; padding: 3pt">',
 			 '<a href="', $scripturl, '?action=search', '"><strong>Cauta in forum</strong></a> | ',
Index: www/controllers/attachment.php
===================================================================
--- www/controllers/attachment.php	(revision 1164)
+++ www/controllers/attachment.php	(working copy)
@@ -1,11 +1,12 @@
 <?php
 
-require_once(IA_ROOT_DIR."www/format/pager.php");
-require_once(IA_ROOT_DIR."common/db/textblock.php");
-require_once(IA_ROOT_DIR."common/db/attachment.php");
-require_once(IA_ROOT_DIR.'www/controllers/zip_attachment.php');
-require_once(IA_ROOT_DIR."common/external_libs/zipfile.php");
-require_once(IA_ROOT_DIR."common/avatar.php");
+require_once(IA_ROOT_DIR . 'www/format/pager.php');
+require_once(IA_ROOT_DIR . 'common/db/textblock.php');
+require_once(IA_ROOT_DIR . 'common/db/attachment.php');
+require_once(IA_ROOT_DIR . 'www/controllers/zip_attachment.php');
+require_once(IA_ROOT_DIR . 'common/external_libs/zipfile.php');
+require_once(IA_ROOT_DIR . 'common/avatar.php');
+require_once(IA_ROOT_DIR . 'common/db/user.php');
 
 // Try to get the textblock model for a certain page.
 // If it fails it will flash and redirect
@@ -328,6 +329,7 @@ function controller_attachment_delete($page_name, $file_name, $more_files = 0) {
     // Delete the resizedimages in case the page is an avatar
     $matches = get_page_user_name($page_name);
     if (is_avatar_attachment($file_name, $page_name)) {
+        user_update(identity_get_user());
         avatar_delete($matches[1]);
     }
     // We've got big balls.
Index: www/controllers/json.php
===================================================================
--- www/controllers/json.php	(revision 1164)
+++ www/controllers/json.php	(working copy)
@@ -39,7 +39,7 @@ function controller_json($suburl) {
             );
 
             // output JSON
-            execute_view_die('views/json.php', $view);
+            execute_view_die('views/json.php', $view, true);
 
         case 'task-get-rounds':
             // Return list of parent rounds for a task
@@ -57,7 +57,7 @@ function controller_json($suburl) {
             );
 
             // Output JSON
-            execute_view_die('views/json.php', $view);
+            execute_view_die('views/json.php', $view, true);
         default:
             die_http_error(400, 'Actiune invalida.');
     }
Index: www/controllers/login.php
===================================================================
--- www/controllers/login.php	(revision 1164)
+++ www/controllers/login.php	(working copy)
@@ -1,6 +1,7 @@
 <?php
 
-require_once(IA_ROOT_DIR . "common/db/user.php");
+require_once(IA_ROOT_DIR . 'common/db/user.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/textblock.php');
 
 function controller_login() {
     global $identity_user;
@@ -81,14 +82,31 @@ function controller_login() {
     // always reset password before displaying web form
     $data['password'] = '';
 
-    $view['page_name'] = "login";
-    $view['title'] = "Autentificare";
-    $view['form_values'] = $data;
-    $view['form_errors'] = array();
-    $view['topnav_select'] = 'login';
-    $view['no_sidebar_login'] = true;
+    $textblock = textblock_get_revision('template/login');
+    log_assert($textblock, "Pagina template/login lipseste");
+    $textblock['text'] = wiki_process_textblock($textblock);
 
-    execute_view_die('views/login.php', $view);
+    $login_form =
+      <x:frag>
+        <h1>
+          Autentificare
+        </h1>
+        <p>
+          Daca nu esti inregistrat deja, te poti
+          <ui:link href={url_register()}>
+            inregistra aici
+          </ui:link>
+          ; daca ti-ai uitat parola, o poti
+          <ui:link href={url_resetpass()}>
+            reseta aici
+          </ui:link>
+          .
+        </p>
+        <ia:login_form values={$data}/>
+        <ui:textblock textblock={$textblock} show_forum={false} />
+      </x:frag>;
+
+    execute_render_die($login_form, 'Autentificare', 'login', true);
 }
 
 ?>
Index: www/controllers/textblock.php
===================================================================
--- www/controllers/textblock.php	(revision 1164)
+++ www/controllers/textblock.php	(working copy)
@@ -1,13 +1,56 @@
 <?php
 
-require_once(IA_ROOT_DIR . "www/format/pager.php");
-require_once(IA_ROOT_DIR . "common/db/textblock.php");
-require_once(IA_ROOT_DIR . "common/textblock.php");
-require_once(IA_ROOT_DIR . "common/diff.php");
+require_once(IA_ROOT_DIR . 'www/format/pager.php');
+require_once(IA_ROOT_DIR . 'common/db/textblock.php');
+require_once(IA_ROOT_DIR . 'common/textblock.php');
+require_once(IA_ROOT_DIR . 'common/diff.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/textblock.php');
+function controller_textblock_render($page_name, $revision_number = null) {
+    $current_page = textblock_get_revision($page_name);
+
+    if ($current_page) {
+        $revision_count = textblock_get_revision_count($page_name);
+
+        if ($revision_number && $revision_number != $revision_count) {
+            if (!is_numeric($revision_number) || (int)$revision_number < 1) {
+                flash_error('Revizia "' . $revision_number . '" este invalida.');
+                redirect(url_textblock($page_name));
+            } else {
+                $reivison_number = (int)$revision_number;
+            }
 
+            identity_require("textblock-history", $current_page);
+            $page = textblock_get_revision($page_name, $revision_number);
+
+            if (!$page) {
+                flash_error('Revizia "' . $revision_number . '" nu exista.');
+                redirect(url_textblock($page_name));
+            }
+        } else {
+            identity_require('textblock-view', $current_page);
+            $page = $current_page;
+        }
+    } else {
+        // Missing page
+        flash_error("Nu exista pagina, dar poti sa o creezi ...");
+        redirect(url_textblock_edit($page_name));
+    }
+
+    log_assert_valid(textblock_validate($page));
+
+    $page['type'] = 'textblock';
+    $page['text'] = wiki_process_textblock($page);
+    $permitted_actions = identity_actions($page);
+
+    $textblock =
+      <ui:textblock textblock={$page} show_forum={true} revision={$revision_number}
+          revision_count={$revision_count} permitted_actions={$permitted_actions} />;
+
+    execute_render_die($textblock, $page['title']);
+}
 
-// View a plain textblock.
-// That textblock can be owned by something else.
+// DEPRECATED
+// FIXME: remove this once the newsletter is rewritten in XHP too
 function controller_textblock_view($page_name, $rev_num = null,
         $display_view = 'views/textblock_view.php') {
     global $identity_user;
Index: www/format/format.php
===================================================================
--- www/format/format.php	(revision 1164)
+++ www/format/format.php	(working copy)
@@ -104,6 +104,13 @@ function format_post_link($url, $content, $post_data = array(), $escape = true,
 // FIXME: Improve this logic.
 function format_highlight_access_key($string, $key) {
     if (($pos = stripos($string, $key)) !== false) {
+        require_once(IA_ROOT_DIR . 'www/xhp/base/init.php');
+        return
+            <x:frag>
+                {substr($string, 0, $pos)}
+                <span class="access-key">{$string[$pos]}</span>
+                {substr($string, $pos + 1)}
+            </x:frag>;
         return substr_replace($string,
                 '<span class="access-key">'.$string[$pos].'</span>', $pos, 1);
     } else {
Index: www/identity.php
===================================================================
--- www/identity.php	(revision 1164)
+++ www/identity.php	(working copy)
@@ -62,6 +62,17 @@ function identity_can($action, $object = null) {
     return security_query($identity_user, $action, $object);
 }
 
+/**
+ * Returns the actions the current user is allowed on an object
+ *
+ * @param  array  object
+ * @return array
+ */
+function identity_actions($object) {
+    global $identity_user;
+    return security_actions_query($identity_user, $object);
+}
+
 // Require login first.
 // It makes a lot of sense to separate this from security. No matter what
 // dumb little security.php might say, some things absolutely require login.
Index: www/index.php
===================================================================
--- www/index.php	(revision 1164)
+++ www/index.php	(working copy)
@@ -324,7 +324,7 @@ else if (IA_NEWSLETTER_TEXTBLOCK_PREFIX == $urlstart.'/'
 // general textblock view
 else if ($action == 'view') {
     require_once(IA_ROOT_DIR.'www/controllers/textblock.php');
-    controller_textblock_view($page, request('revision'));
+    controller_textblock_render($page, request('revision'));
 }
 
 // invalid URL
Index: www/macros/macro_gallery.php
===================================================================
--- www/macros/macro_gallery.php	(revision 1164)
+++ www/macros/macro_gallery.php	(working copy)
@@ -39,16 +39,19 @@ function macro_gallery($args) {
     $atts = attachment_get_all($page, $file, $options['first_entry'], $options['display_entries']);
 
     // display gallery
-    $buffer = '<div class="gallery"><div class="images">';
+    $gallery = <div class="images" />;
     foreach ($atts as $attach) {
         $thumbsrc = url_image_resize($attach['page'], $attach['name'], "130x80");
         $fullsrc = url_image_resize($attach['page'], $attach['name'], null);
-        $buffer .= "<a href=\"".html_escape($fullsrc)."\"><img src=\"".html_escape($thumbsrc)."\" alt=\"".html_escape($attach['page'])."\" /></a>";
+        $gallery -> appendChild(<ui:link href={$fullsrc}> <img src={$thumbsrc} alt={$attach['page']} /> </ui:link>);
     }
-    $buffer .= '</div>';
-    $buffer .= format_pager($options);
-    $buffer .= '</div>';
 
+    return
+      <div class="gallery">
+        {$gallery}
+        <ui:pager:page-number display_entries={$options['display_entries']} total_entries={$options['total_entries']}
+            first_entry={$options['first_entry']} show_count={true} />
+      </div>;
     return $buffer;
 }
 
Index: www/macros/macro_rankings.php
===================================================================
--- www/macros/macro_rankings.php	(revision 1164)
+++ www/macros/macro_rankings.php	(working copy)
@@ -1,9 +1,11 @@
 <?php
 
-require_once(IA_ROOT_DIR . "www/format/table.php");
-require_once(IA_ROOT_DIR . "www/format/pager.php");
-require_once(IA_ROOT_DIR . "www/format/format.php");
-require_once(IA_ROOT_DIR . "common/db/score.php");
+require_once(IA_ROOT_DIR . 'www/format/pager.php');
+require_once(IA_ROOT_DIR . 'www/format/format.php');
+require_once(IA_ROOT_DIR . 'common/db/score.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/user.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/table.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/pager.php');
 
 // Displays *interactive* rankings table summing up score points from a
 // pre-defined set of contest rounds.
@@ -40,8 +42,6 @@ function macro_rankings($args) {
 
     // Paginator options
     $options = pager_init_options($args);
-    $options['show_count'] = true;
-    $options['css_class'] = 'sortable';
 
     // Rounds parameters
     $roundstr = getattr($args, 'rounds', '');
@@ -63,20 +63,13 @@ function macro_rankings($args) {
 
     // Generating Table
 
-    $column_infos = array(
-        array(
-            'title' => 'Pozitie',
-            'key' => 'ranking',
-            'css_class' => 'number rank'
-        ),
-        array(
-            'title' => 'Nume',
-            'key' => 'user_full',
-            'rowform' => function($row) {
-                return format_user_normal($row['user_name'], $row['user_full'], $row['user_rating']);
-            },
-        ),
-    );
+    $header =
+      <x:frag>
+        <th class="number rank">
+          {'Pozitie'}
+        </th>
+        Nume
+      </x:frag>;
 
     $columns = array();
     $tasks = array();
@@ -87,63 +80,74 @@ function macro_rankings($args) {
             if ($detail_task == true) {
                 $new_tasks = round_get_tasks($round_id);
                 foreach ($new_tasks as $task) {
-                    array_push($columns, array(
-                        'name' => $task['id'],
-                        'type' => 'task',
-                        'title' => $task['title']
-                    ));
+                    $header -> appendChild(<th class="number score">
+                                          {$task['title']}
+                                        </th>);
+                    $columns[] = 'task_scores_' . $task['id'];
                     array_push($tasks, $task['id']);
                 }
             }
 
             if ($detail_round == true) {
-                array_push($columns, array(
-                    'name' => $round['round_id'],
-                    'type' => 'round',
-                    'title' => $round['round_name']
-                ));
+                $header -> appendChild(<th class="number score">
+                                      {$round['round_name']}
+                                    </th>);
+                $columns[] = 'round_scores_' . $round['round_id'];
             }
         }
     }
 
-    foreach ($columns as $column) {
-        array_push($column_infos, array(
-            'title' => $column['title'],
-            'key' => $column['name'],
-            'rowform' => function($row) use ($column) {
-                return round($row[$column['name']]);
-            },
-            'css_class' => 'number score'
-        ));
-    }
-
     $total = 'Scor';
     if ($detail_round == true || $detail_task == true) {
         $total = 'Total';
     }
-    array_push($column_infos, array(
-        'title' => $total,
-        'key' => 'score',
-        'rowform' => function($row) {
-            return round($row['score']);
-        },
-        'css_class' => 'number score'
-    ));
+    $header -> appendChild(<th class="number score">
+                             {$total}
+                           </th>);
+
+    $content = <x:frag />;
 
     $round_ids = array();
     foreach ($rounds as $round) {
         array_push($round_ids, $round['round_id']);
     }
     $rankings = score_get_rankings($round_ids, $tasks, $options['first_entry'], $options['display_entries'], $detail_task, $detail_round);
-
-    if (pager_needs_total_entries($options)) {
-        $options['total_entries'] = score_get_count(null, null, $round_ids);
+    foreach ($rankings as $user) {
+        $content -> appendChild(<x:frag>
+                                  <td class="number rank">
+                                    {$user['ranking']}
+                                  </td>
+                                  <ui:user:normal user={$user} />
+                                </x:frag>);
+        foreach ($columns as $column) {
+            $content -> appendChild(<td class="number score">
+                                      {(int)$user[$column]}
+                                    </td>);
+        }
+        $content -> appendChild(<td class="number score">
+                                {(int)$user['score']}
+                              </td>);
     }
 
+    $options['total_entries'] = score_get_count(null, null, $round_ids);
+
     if (0 >= count($rankings)) {
         return macro_message('Nici un rezultat inregistrat pentru aceasta runda.');
     } else {
-        return format_table($rankings, $column_infos, $options);
+        $pager =
+          <ui:pager:page-number first_entry={$options['first_entry']} display_entries={$options['display_entries']}
+            total_entries={$options['total_entries']} show_count={true} show_display_entries={true}
+            prefix="rankings_"/>;
+
+        return
+          <x:frag>
+            {$pager}
+            <ui:table sortable={true} cols={count($columns) + 3} >
+              {$header}
+              {$content}
+            </ui:table>
+            {$pager}
+          </x:frag>;
     }
 }
 
Index: www/macros/macro_remotebox.php
===================================================================
--- www/macros/macro_remotebox.php	(revision 1164)
+++ www/macros/macro_remotebox.php	(working copy)
@@ -17,13 +17,15 @@ function macro_remotebox($url, $bypass_security = false) {
         return macro_error('Expecting argument `url`');
     }
 
-    $buffer = '';
-    $buffer .= '<div id="remotebox">remote content</div>';
-    $buffer .= '<script type="text/javascript">RemoteBox_Url="';
-    $buffer .= html_escape($url);
-    $buffer .= '";</script>';
+    $remotebox =
+      <x:frag>
+        <div id="remotebox">remote content</div>
+        <script type="text/javascript">
+          {HTML('RemoteBox_Url="' . html_escape($url) . '"')}
+        </script>
+      </x:frag>;
 
-    return $buffer;
+    return $remotebox;
 }
 
 ?>
Index: www/macros/macro_smfcomments.php
===================================================================
--- www/macros/macro_smfcomments.php	(revision 1164)
+++ www/macros/macro_smfcomments.php	(working copy)
@@ -14,7 +14,7 @@ require_once(IA_ROOT_DIR.'www/macros/macro_remotebox.php');
 //      SmfComments( topic_id="400" display="show" )
 //      SmfComments( topic_id="400" display="hide" max_comm="5")
 function macro_smfcomments($args) {
-    $comments = '<div id="comentarii">';
+    $comments = <div id="comentarii" />;
 
     $topic_id = getattr($args, 'topic_id');
     $display = getattr($args, 'display');
@@ -43,9 +43,7 @@ function macro_smfcomments($args) {
         $url .= '&max_comm=' . $max_comm;
     }
 
-    $comments .= macro_remotebox($url, true);
-    $comments .= '</div>';
-
+    $comments -> appendChild(macro_remotebox($url, true));
     return $comments;
 }
 
